/*
  lpc8/sct.h 
  Copyright 2013 Marc Prager
 
  This file is part of the c-lpc8 library.
  c-lpc8 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 
  c-lpc8 is published in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License along with c-lpc8.
  If not see <http://www.gnu.org/licenses/>
 */

#ifndef lpc8__sct_h
#define lpc8__sct_h

#include <integers.h>
#include <unionized.h>

union PACKED4 Sct {
	//.0x000
	unionized struct PACKED { char _0[0x000]; // padding
	volatile Uint32		config;
	unionized };

	//.0x004
	unionized struct PACKED { char _1[0x004]; // padding
	volatile Uint32		ctrl;
	unionized };

	//.0x004
	unionized struct PACKED { char _2[0x004]; // padding
	volatile Uint16		ctrlL;
	unionized };

	//.0x006
	unionized struct PACKED { char _3[0x006]; // padding
	volatile Uint16		ctrlH;
	unionized };

	//.0x008
	unionized struct PACKED { char _4[0x008]; // padding
	volatile Uint32		limit;
	unionized };

	//.0x008
	unionized struct PACKED { char _5[0x008]; // padding
	volatile Uint16		limitL;
	unionized };

	//.0x00A
	unionized struct PACKED { char _6[0x00A]; // padding
	volatile Uint16		limitH;
	unionized };

	//.0x00C
	unionized struct PACKED { char _7[0x00C]; // padding
	volatile Uint32		halt;
	unionized };

	//.0x00C
	unionized struct PACKED { char _8[0x00C]; // padding
	volatile Uint16		haltL;
	unionized };

	//.0x00E
	unionized struct PACKED { char _9[0x00E]; // padding
	volatile Uint16		haltH;
	unionized };

	//.0x010
	unionized struct PACKED { char _10[0x010]; // padding
	volatile Uint32		stop;
	unionized };

	//.0x010
	unionized struct PACKED { char _11[0x010]; // padding
	volatile Uint16		stopL;
	unionized };

	//.0x012
	unionized struct PACKED { char _12[0x012]; // padding
	volatile Uint16		stopH;
	unionized };

	//.0x014
	unionized struct PACKED { char _13[0x014]; // padding
	volatile Uint32		start;
	unionized };

	//.0x014
	unionized struct PACKED { char _14[0x014]; // padding
	volatile Uint16		startL;
	unionized };

	//.0x016
	unionized struct PACKED { char _15[0x016]; // padding
	volatile Uint16		startH;
	unionized };

	//.0x040
	unionized struct PACKED { char _16[0x040]; // padding
	volatile Uint32		count;
	unionized };

	//.0x040
	unionized struct PACKED { char _17[0x040]; // padding
	volatile Uint16		countL;
	unionized };

	//.0x042
	unionized struct PACKED { char _18[0x042]; // padding
	volatile Uint16		countH;
	unionized };

	//.0x044
	unionized struct PACKED { char _19[0x044]; // padding
	volatile Uint32		state;
	unionized };

	//.0x044
	unionized struct PACKED { char _20[0x044]; // padding
	volatile Uint16		stateL;
	unionized };

	//.0x046
	unionized struct PACKED { char _21[0x046]; // padding
	volatile Uint16		stateH;
	unionized };

	//.0x048
	unionized struct PACKED { char _22[0x048]; // padding
	volatile Uint32		input;
	unionized };

	//.0x04C
	unionized struct PACKED { char _23[0x04C]; // padding
	volatile Uint32		regmode;
	unionized };

	//.0x04C
	unionized struct PACKED { char _24[0x04C]; // padding
	volatile Uint16		regmodeL;
	unionized };

	//.0x04E
	unionized struct PACKED { char _25[0x04E]; // padding
	volatile Uint16		regmodeH;
	unionized };

	//.0x050
	unionized struct PACKED { char _26[0x050]; // padding
	volatile Uint32		output;
	unionized };

	//.0x054
	unionized struct PACKED { char _27[0x054]; // padding
	volatile Uint32		outputDirCtrl;
	unionized };

	//.0x058
	unionized struct PACKED { char _28[0x058]; // padding
	volatile Uint32		res;
	unionized };

	//.0x0F0
	unionized struct PACKED { char _29[0x0F0]; // padding
	volatile Uint32		evEn;		///< event enable
	unionized };

	//.0x0F4
	unionized struct PACKED { char _30[0x0F4]; // padding
	volatile Uint32		evFlag;		///<
	unionized };

	//.0x0F8
	unionized struct PACKED { char _31[0x0F8]; // padding
	volatile Uint32		conEn;		///<
	unionized };

	//.0x0FC
	unionized struct PACKED { char _32[0x0FC]; // padding
	volatile Uint32		conFlag;	///<
	unionized };

	////////////////////////////////////////////////////////////////////////////////////////////////////	
	// match registers

	//.0x100
	unionized struct PACKED { char _33[0x100]; // padding
	volatile Uint32		match[5];
	unionized };

	//.0x100
	unionized struct PACKED { char _34[0x100]; // padding
	volatile Uint32		match0;
	unionized };

	//.0x104
	unionized struct PACKED { char _35[0x104]; // padding
	volatile Uint32		match1;
	unionized };

	//.0x108
	unionized struct PACKED { char _36[0x108]; // padding
	volatile Uint32		match2;
	unionized };

	//.0x10C
	unionized struct PACKED { char _37[0x10C]; // padding
	volatile Uint32		match3;
	unionized };

	//.0x110
	unionized struct PACKED { char _38[0x110]; // padding
	volatile Uint32		match4;
	unionized };

	//.0x100
	unionized struct PACKED { char _39[0x100]; // padding
	volatile Uint16		matchL0;
	unionized };

	//.0x104
	unionized struct PACKED { char _40[0x104]; // padding
	volatile Uint16		matchL1;
	unionized };

	//.0x108
	unionized struct PACKED { char _41[0x108]; // padding
	volatile Uint16		matchL2;
	unionized };

	//.0x10C
	unionized struct PACKED { char _42[0x10C]; // padding
	volatile Uint16		matchL3;
	unionized };

	//.0x110
	unionized struct PACKED { char _43[0x110]; // padding
	volatile Uint16		matchL4;
	unionized };

	//.0x102
	unionized struct PACKED { char _44[0x102]; // padding
	volatile Uint16		matchH0;
	unionized };

	//.0x106
	unionized struct PACKED { char _45[0x106]; // padding
	volatile Uint16		matchH1;
	unionized };

	//.0x10A
	unionized struct PACKED { char _46[0x10A]; // padding
	volatile Uint16		matchH2;
	unionized };

	//.0x10E
	unionized struct PACKED { char _47[0x10E]; // padding
	volatile Uint16		matchH3;
	unionized };

	//.0x112
	unionized struct PACKED { char _48[0x112]; // padding
	volatile Uint16		matchH4;
	unionized };

	//.0x200
	unionized struct PACKED { char _49[0x200]; // padding
	volatile Uint32		matchRel[5];
	unionized };

	//.0x200
	unionized struct PACKED { char _50[0x200]; // padding
	volatile Uint32		matchRel0;
	unionized };

	//.0x204
	unionized struct PACKED { char _51[0x204]; // padding
	volatile Uint32		matchRel1;
	unionized };

	//.0x208
	unionized struct PACKED { char _52[0x208]; // padding
	volatile Uint32		matchRel2;
	unionized };

	//.0x20C
	unionized struct PACKED { char _53[0x20C]; // padding
	volatile Uint32		matchRel3;
	unionized };

	//.0x210
	unionized struct PACKED { char _54[0x210]; // padding
	volatile Uint32		matchRel4;
	unionized };

	//.0x200
	unionized struct PACKED { char _55[0x200]; // padding
	volatile Uint16		matchRelL0;
	unionized };

	//.0x204
	unionized struct PACKED { char _56[0x204]; // padding
	volatile Uint16		matchRelL1;
	unionized };

	//.0x208
	unionized struct PACKED { char _57[0x208]; // padding
	volatile Uint16		matchRelL2;
	unionized };

	//.0x20C
	unionized struct PACKED { char _58[0x20C]; // padding
	volatile Uint16		matchRelL3;
	unionized };

	//.0x210
	unionized struct PACKED { char _59[0x210]; // padding
	volatile Uint16		matchRelL4;
	unionized };

	//.0x202
	unionized struct PACKED { char _60[0x202]; // padding
	volatile Uint16		matchRelH0;
	unionized };

	//.0x206
	unionized struct PACKED { char _61[0x206]; // padding
	volatile Uint16		matchRelH1;
	unionized };

	//.0x20A
	unionized struct PACKED { char _62[0x20A]; // padding
	volatile Uint16		matchRelH2;
	unionized };

	//.0x20E
	unionized struct PACKED { char _63[0x20E]; // padding
	volatile Uint16		matchRelH3;
	unionized };

	//.0x212
	unionized struct PACKED { char _64[0x212]; // padding
	volatile Uint16		matchRelH4;
	unionized };

	////////////////////////////////////////////////////////////////////////////////////////////////////	
	// capture registers
	//.0x100
	unionized struct PACKED { char _65[0x100]; // padding
	volatile Uint32		cap[5];
	unionized };

	//.0x100
	unionized struct PACKED { char _66[0x100]; // padding
	volatile Uint32		cap0;
	unionized };

	//.0x104
	unionized struct PACKED { char _67[0x104]; // padding
	volatile Uint32		cap1;
	unionized };

	//.0x108
	unionized struct PACKED { char _68[0x108]; // padding
	volatile Uint32		cap2;
	unionized };

	//.0x10C
	unionized struct PACKED { char _69[0x10C]; // padding
	volatile Uint32		cap3;
	unionized };

	//.0x110
	unionized struct PACKED { char _70[0x110]; // padding
	volatile Uint32		cap4;
	unionized };

	//.0x100
	unionized struct PACKED { char _71[0x100]; // padding
	volatile Uint16		capL0;
	unionized };

	//.0x104
	unionized struct PACKED { char _72[0x104]; // padding
	volatile Uint16		capL1;
	unionized };

	//.0x108
	unionized struct PACKED { char _73[0x108]; // padding
	volatile Uint16		capL2;
	unionized };

	//.0x10C
	unionized struct PACKED { char _74[0x10C]; // padding
	volatile Uint16		capL3;
	unionized };

	//.0x110
	unionized struct PACKED { char _75[0x110]; // padding
	volatile Uint16		capL4;
	unionized };

	//.0x102
	unionized struct PACKED { char _76[0x102]; // padding
	volatile Uint16		capH0;
	unionized };

	//.0x106
	unionized struct PACKED { char _77[0x106]; // padding
	volatile Uint16		capH1;
	unionized };

	//.0x10A
	unionized struct PACKED { char _78[0x10A]; // padding
	volatile Uint16		capH2;
	unionized };

	//.0x10E
	unionized struct PACKED { char _79[0x10E]; // padding
	volatile Uint16		capH3;
	unionized };

	//.0x112
	unionized struct PACKED { char _80[0x112]; // padding
	volatile Uint16		capH4;
	unionized };

	//.0x200
	unionized struct PACKED { char _81[0x200]; // padding
	volatile Uint32		capCtrl[5];
	unionized };

	//.0x200
	unionized struct PACKED { char _82[0x200]; // padding
	volatile Uint32		capCtrl0;
	unionized };

	//.0x204
	unionized struct PACKED { char _83[0x204]; // padding
	volatile Uint32		capCtrl1;
	unionized };

	//.0x208
	unionized struct PACKED { char _84[0x208]; // padding
	volatile Uint32		capCtrl2;
	unionized };

	//.0x20C
	unionized struct PACKED { char _85[0x20C]; // padding
	volatile Uint32		capCtrl3;
	unionized };

	//.0x210
	unionized struct PACKED { char _86[0x210]; // padding
	volatile Uint32		capCtrl4;
	unionized };

	//.0x200
	unionized struct PACKED { char _87[0x200]; // padding
	volatile Uint16		capCtrlL0;
	unionized };

	//.0x204
	unionized struct PACKED { char _88[0x204]; // padding
	volatile Uint16		capCtrlL1;
	unionized };

	//.0x208
	unionized struct PACKED { char _89[0x208]; // padding
	volatile Uint16		capCtrlL2;
	unionized };

	//.0x20C
	unionized struct PACKED { char _90[0x20C]; // padding
	volatile Uint16		capCtrlL3;
	unionized };

	//.0x210
	unionized struct PACKED { char _91[0x210]; // padding
	volatile Uint16		capCtrlL4;
	unionized };

	//.0x202
	unionized struct PACKED { char _92[0x202]; // padding
	volatile Uint16		capCtrlH0;
	unionized };

	//.0x206
	unionized struct PACKED { char _93[0x206]; // padding
	volatile Uint16		capCtrlH1;
	unionized };

	//.0x20A
	unionized struct PACKED { char _94[0x20A]; // padding
	volatile Uint16		capCtrlH2;
	unionized };

	//.0x20E
	unionized struct PACKED { char _95[0x20E]; // padding
	volatile Uint16		capCtrlH3;
	unionized };

	//.0x212
	unionized struct PACKED { char _96[0x212]; // padding
	volatile Uint16		capCtrlH4;
	unionized };

	////////////////////////////////////////////////////////////////////////////////////////////////////
	//.0x300
	unionized struct PACKED { char _97[0x300]; // padding
	volatile Uint32		evState0;
	unionized };

	//.0x304
	unionized struct PACKED { char _98[0x304]; // padding
	volatile Uint32		evCtrl0;
	unionized };

	//.0x308
	unionized struct PACKED { char _99[0x308]; // padding
	volatile Uint32		evState1;
	unionized };

	//.0x30C
	unionized struct PACKED { char _100[0x30C]; // padding
	volatile Uint32		evCtrl1;
	unionized };

	//.0x310
	unionized struct PACKED { char _101[0x310]; // padding
	volatile Uint32		evState2;
	unionized };

	//.0x314
	unionized struct PACKED { char _102[0x314]; // padding
	volatile Uint32		evCtrl2;
	unionized };

	//.0x318
	unionized struct PACKED { char _103[0x318]; // padding
	volatile Uint32		evState3;
	unionized };

	//.0x31C
	unionized struct PACKED { char _104[0x31C]; // padding
	volatile Uint32		evCtrl3;
	unionized };

	//.0x320
	unionized struct PACKED { char _105[0x320]; // padding
	volatile Uint32		evState4;
	unionized };

	//.0x324
	unionized struct PACKED { char _106[0x324]; // padding
	volatile Uint32		evCtrl4;
	unionized };

	//.0x328
	unionized struct PACKED { char _107[0x328]; // padding
	volatile Uint32		evState5;
	unionized };

	//.0x32C
	unionized struct PACKED { char _108[0x32C]; // padding
	volatile Uint32		evCtrl5;
	unionized };

	//.0x500
	unionized struct PACKED { char _109[0x500]; // padding
	volatile Uint32		outSet0;
	unionized };

	//.0x504
	unionized struct PACKED { char _110[0x504]; // padding
	volatile Uint32		outClr0;
	unionized };

	//.0x508
	unionized struct PACKED { char _111[0x508]; // padding
	volatile Uint32		outSet1;
	unionized };

	//.0x50C
	unionized struct PACKED { char _112[0x50C]; // padding
	volatile Uint32		outClr1;
	unionized };

	//.0x510
	unionized struct PACKED { char _113[0x510]; // padding
	volatile Uint32		outSet2;
	unionized };

	//.0x514
	unionized struct PACKED { char _114[0x514]; // padding
	volatile Uint32		outClr2;
	unionized };

	//.0x518
	unionized struct PACKED { char _115[0x518]; // padding
	volatile Uint32		outSet3;
	unionized };

	//.0x51C
	unionized struct PACKED { char _116[0x51C]; // padding
	volatile Uint32		outClr3;
	unionized };
};

extern union Sct SCT;	///< defined in crt0

enum SctConfigBits {
	_SCT_CONFIG_UNIFY	=0,	///< 1 bit: 0=2 16bit independend counters, 1=32bit unified
		SCT_CONFIG_UNIFIY_16BIT_	=0,	///< two (nearly) independend timers of 16 bits
		SCT_CONFIG_UNIFIY_32BIT_	=1,	///< one timer of 32 bits
	_SCT_CONFIG_CLKMODE	=1,	///< 2 bits: 0=bus clock, 1=high perf. sampled clock, 2=low power sampled clk
		SCT_CONFIG_CLKMODE_PCLK_	=0,	///< SCT clock is bus clock
		SCT_CONFIG_CLKMODE_PCLK_SAMPLE_	=1,	///< SCT clock is sampled clock, PCLK still drives SCT
		SCT_CONFIG_CLKMODE_SAMPLE_	=2,	///< SCT clock is sampled clock, synced to PCLK. low power.
	_SCT_CONFIG_CLKSEL	=2,	///< 4 bits: SCT clock input
		SCT_CONFIG_CLKSEL_IN0_RISING_	=0,
		SCT_CONFIG_CLKSEL_IN0_FALLING_	=1,
		SCT_CONFIG_CLKSEL_IN1_RISING_	=2,
		SCT_CONFIG_CLKSEL_IN1_FALLING_	=3,
		SCT_CONFIG_CLKSEL_IN2_RISING_	=4,
		SCT_CONFIG_CLKSEL_IN2_FALLING_	=5,
		SCT_CONFIG_CLKSEL_IN3_RISING_	=6,
		SCT_CONFIG_CLKSEL_IN3_FALLING_	=7,
		// all others reserved
	_SCT_CONFIG_NORELOAD	=7,	///< 1 bit: 0=match reload, 1=prevent match reload
	_SCT_CONFIG_NORELOAD_L	=7,	///< 1 bit: 0=match reload, 1=prevent match reload
	_SCT_CONFIG_NORELOAD_H	=8,	///< 1 bit: 0=match reload, 1=prevent match reload
	_SCT_CONFIG_INSYNC	=9,	///< 8 bits: 0=IN0..IN7 SCT clock sync
		SCT_CONFIG_INSYNC_IN0_	=1<<0,
		SCT_CONFIG_INSYNC_IN1_	=1<<1,
		SCT_CONFIG_INSYNC_IN2_	=1<<2,
		SCT_CONFIG_INSYNC_IN3_	=1<<3,
		// all others reserved (on this microcontroller)
	_SCT_CONFIG_AUTOLIMIT	=17,	///< 1 bit: 1=creates a LIMIT condition on match0
	_SCT_CONFIG_AUTOLIMIT_L	=17,	///< 1 bit: 1=creates a LIMIT condition on match0
	_SCT_CONFIG_AUTOLIMIT_H	=18,	///< 1 bit: 1=creates a LIMIT condition on match0
};

enum SctCtrlBits {
	_SCT_CTRL_DOWN		=0,	///< 1 bit, hardware-set: this is 1 if counter is counting down, 0 if up.
	_SCT_CTRL_STOP		=1,	///< 1 bit: 0=counter running, 1=counter stopped but events can occur.
	_SCT_CTRL_HALT		=2,	///< 1 bit: 0=counter running, 1=counter doesn't run and no events can occur.
	_SCT_CTRL_CLRCTR	=3,	///< 1 bit: writing 1 clears the counter; always reads 0.
	_SCT_CTRL_BIDIR		=4,	///< 1 bit: 0=count up then reset, 1=count up to limit, then down, then up,...
	_SCT_CTRL_PRE		=5,	///< 8 bits: this value+1 = prescaler for counter clock.

	_SCT_CTRL_DOWN_L	=0,	///< 1 bit, hardware-set: this is 1 if counter is counting down, 0 if up.
	_SCT_CTRL_STOP_L	=1,	///< 1 bit: 0=counter running, 1=counter stopped but events can occur.
	_SCT_CTRL_HALT_L	=2,	///< 1 bit: 0=counter running, 1=counter doesn't run and no events can occur.
	_SCT_CTRL_CLRCTR_L	=3,	///< 1 bit: writing 1 clears the counter; always reads 0.
	_SCT_CTRL_BIDIR_L	=4,	///< 1 bit: 0=count up then reset, 1=count up to limit, then down, then up,...
	_SCT_CTRL_PRE_L		=5,	///< 8 bits: this value+1 = prescaler for counter clock.

	_SCT_CTRL_DOWN_H	=16+0,	///< 1 bit, hardware-set: this is 1 if counter is counting down, 0 if up.
	_SCT_CTRL_STOP_H	=16+1,	///< 1 bit: 0=counter running, 1=counter stopped but events can occur.
	_SCT_CTRL_HALT_H	=16+2,	///< 1 bit: 0=counter running, 1=counter doesn't run and no events can occur.
	_SCT_CTRL_CLRCTR_H	=16+3,	///< 1 bit: writing 1 clears the counter; always reads 0.
	_SCT_CTRL_BIDIR_H	=16+4,	///< 1 bit: 0=count up then reset, 1=count up to limit, then down, then up,...
	_SCT_CTRL_PRE_H		=16+5,	///< 8 bits: this value+1 = prescaler for counter clock.
};

enum SctEventBit {
	SCT_EVENT0	=1<<0,
	SCT_EVENT1	=1<<1,
	SCT_EVENT2	=1<<2,
	SCT_EVENT3	=1<<3,
	SCT_EVENT4	=1<<4,
	SCT_EVENT5	=1<<5,
};

enum SctLimitBits {
	_SCT_LIMIT_MSK		=0,	///< 6 bits: bit i=0 makes event i a limit event
	_SCT_LIMIT_MSK_L	=0,	///< 6 bits: bit i=0 makes event i a limit event
	_SCT_LIMIT_MSK_H	=16,	///< 6 bits: bit i=0 makes event i a limit event
};

enum SctHaltBits {
	_SCT_HALT_MSK		=0,	///< 6 bits: bit i=0 makes event i a halt event
	_SCT_HALT_MSK_L		=0,	///< 6 bits: bit i=0 makes event i a halt event
	_SCT_HALT_MSK_H		=16,	///< 6 bits: bit i=0 makes event i a halt event
};

enum SctStopBits {
	_SCT_STOP_MSK		=0,	///< 6 bits: bit i=0 makes event i a stop event
	_SCT_STOP_MSK_L		=0,	///< 6 bits: bit i=0 makes event i a stop event
	_SCT_STOP_MSK_H		=16,	///< 6 bits: bit i=0 makes event i a stop event
};

enum SctStartBits {
	_SCT_START_MSK		=0,	///< 6 bits: bit i=0 makes event i a start event
	_SCT_START_MSK_L	=0,	///< 6 bits: bit i=0 makes event i a start event
	_SCT_START_MSK_H	=16,	///< 6 bits: bit i=0 makes event i a start event
};

enum SctStateBits {
	_SCT_STATE		=0,	///< 5 bits: current state.
	_SCT_STATE_L		=0,	///< 5 bits: current state.
	_SCT_STATE_H		=16,	///< 5 bits: current state.
};

enum SctInputBits {
	_SCT_INPUT_AIN0		=0,	///< asynchronous input 0
	_SCT_INPUT_AIN1		=1,	///< asynchronous input 1
	_SCT_INPUT_AIN2		=2,	///< asynchronous input 2
	_SCT_INPUT_AIN3		=3,	///< asynchronous input 3
	_SCT_INPUT_SIN0		=16,	///< synchronized (to SCT clock) input 0
	_SCT_INPUT_SIN1		=17,	///< synchronized (to SCT clock) input 1
	_SCT_INPUT_SIN2		=18,	///< synchronized (to SCT clock) input 2
	_SCT_INPUT_SIN3		=19,	///< synchronized (to SCT clock) input 3
};

enum SctRegmodeBits {
	_SCT_REGMODE		=0,	///< 5 bits for match/capture regs, each: 0=match function(def), 1=capture function
		SCT_REGMODE_MATCH0_	=0<<0,
		SCT_REGMODE_CAPTURE0_	=1<<0,
		SCT_REGMODE_MATCH1_	=0<<1,
		SCT_REGMODE_CAPTURE1_	=1<<1,
		SCT_REGMODE_MATCH2_	=0<<2,
		SCT_REGMODE_CAPTURE2_	=1<<2,
		SCT_REGMODE_MATCH3_	=0<<3,
		SCT_REGMODE_CAPTURE3_	=1<<3,
		SCT_REGMODE_MATCH4_	=0<<4,
		SCT_REGMODE_CAPTURE4_	=1<<4,
	_SCT_REGMODE_L		=0,	///< 5 bits for match/capture regs, each: 0=match function, 1=capture function
	_SCT_REGMODE_H		=16,	///< 5 bits for match/capture regs, each: 0=match function, 1=capture function
};

enum SctOutputDirCtrlBits {
	_SCT_OUTPUTDIRCTRL_SETCLR0	=0,	///< 2 bits: 0=normal, 1=set/clr reversed when L counting down, 2=.. H
		SCT_OUTPUTDIRCTRL_SETCLR_NORMAL_	=0,	///< normal meaning of set/clear
		SCT_OUTPUTDIRCTRL_SETCLR_REVERSE_L_	=1,	///< if L counter counts down: reverse set/clr
		SCT_OUTPUTDIRCTRL_SETCLR_REVERSE_H_	=2,	///< if H counter counts down: reverse set/clr
	_SCT_OUTPUTDIRCTRL_SETCLR1	=2,	///< 2 bits: 0=normal, 1=set/clr reversed when L counting down, 2=.. H
	_SCT_OUTPUTDIRCTRL_SETCLR2	=4,	///< 2 bits: 0=normal, 1=set/clr reversed when L counting down, 2=.. H
	_SCT_OUTPUTDIRCTRL_SETCLR3	=6,	///< 2 bits: 0=normal, 1=set/clr reversed when L counting down, 2=.. H
};

enum SctResBits {
	_SCT_RES0		=0,	///< 2 bits: set/clr conflict resolution: nop/set/clr/toggle
		SCT_RES_NOP_		=0,	///< do nothing
		SCT_RES_SET_		=1,	///< set
		SCT_RES_CLR_		=2,	///< clear
		SCT_RES_TOGGLE_	=3,	///< toggle output
	_SCT_RES1		=2,
	_SCT_RES2		=4,
	_SCT_RES3		=6,
};

enum SctConflagBits {
	_SCT_CONFLAG_NCFLAG	=0,	///< 4 bits: bit i=1 means: no-change conflict on output i; clear by writing 1
	_SCT_CONFLAG_BUSERR	=30,	///< counter L (or unified) was reason of latest bus error.
	_SCT_CONFLAG_BUSERR_L	=30,	///< counter L (or unified) was reason of latest bus error.
	_SCT_CONFLAG_BUSERR_H	=31,	///< counter H was reason of latest bus error.
};

enum SctCapCtrlBits {
	SCT_CAPCTRL_EVENT0	=SCT_EVENT0,		///< capture on event 0
	SCT_CAPCTRL_EVENT1	=SCT_EVENT1,		///< capture on event 1
	SCT_CAPCTRL_EVENT2	=SCT_EVENT2,		///< capture on event 2
	SCT_CAPCTRL_EVENT3	=SCT_EVENT3,		///< capture on event 3
	SCT_CAPCTRL_EVENT4	=SCT_EVENT4,		///< capture on event 4
	SCT_CAPCTRL_EVENT5	=SCT_EVENT5,		///< capture on event 5
};

enum SctEvStateBits {
	SCT_EVSTATE_0_		=1<<0,		///< enable event on state 0
	SCT_EVSTATE_1_		=1<<1,		///< enable event on state 1
};

enum SctEvCtrlBits {
	_SCT_EVCTRL_MATCHSEL	=0,	///< 4 bits: selects the match register (if any) for the event
	_SCT_EVCTRL_HEVENT	=4,	///< 0=select L state and L matches; 1=select H state and H matches
	_SCT_EVCTRL_OUTSEL	=5,	///< 0=select input, 1=select output from IOSEL
	_SCT_EVCTRL_IOSEL	=6,	///< 4 bits: 0=CTIN0/CTOUT0, 1=CTIN1/CTOUT1,...
		SCT_EVCTRL_IOSEL0_	=0,
		SCT_EVCTRL_IOSEL1_	=1,
		SCT_EVCTRL_IOSEL2_	=2,
		SCT_EVCTRL_IOSEL3_	=3,
	_SCT_EVCTRL_IOCOND	=7,	///< 2 bits: IO condition: 0=L,1=rise,2=fall,3=H
		SCT_EVCTRL_IOCOND_LOW_		=0,
		SCT_EVCTRL_IOCOND_RISING_	=1,
		SCT_EVCTRL_IOCOND_FALLING_	=2,
		SCT_EVCTRL_IOCOND_HIGH_		=3,
	_SCT_EVCTRL_COMBMODE	=12,	///< 2 bits: how to combine match and IO
		SCT_EVCTRL_COMBMODE_OR_		=0,	///< match OR IO condition
		SCT_EVCTRL_COMBMODE_MATCH_	=1,	///< match only
		SCT_EVCTRL_COMBMODE_IO_		=2,	///< IO condition only
		SCT_EVCTRL_COMBMODE_AND_	=3,	///< match AND IO condition at the same time
	_SCT_EVCTRL_STATELD	=14,	///< controls if STATEV is added (0) or loaded (1) into state
		SCT_EVCTRL_STATELD_ADD_		=0,	///< add STATEV to state, ignoring carry
		SCT_EVCTRL_STATELD_LOAD_	=1,	///< overwrite state with the STATEV value
	_SCT_EVCTRL_STATEV	=15,	///< 5 bits: state, only 0 and 1 allowed on LPC800, though.
	_SCT_EVCTRL_MATCHMEM	=20,	///< 1=make matches sticky, 0=match only for one cycle.
	_SCT_EVCTRL_DIR		=21,	///< 2 bits: direction dependency of event in BIDIR mode
		SCT_EVCTRL_DIR_ANY_	=0,	///< direction doesn't matter
		SCT_EVCTRL_DIR_UP_	=1,	///< trigger event when counting up, only
		SCT_EVCTRL_DIR_DOWN_	=2,	///< trigger event when counting down, only
};

#endif

