#include <lpc8/systick.h>
#include <lpc8/systickTimer.h>

volatile int systickTimerMs;
static int ms;		// increment value

void handlerSystick(void) {
	systickTimerMs += ms;
	(void)SYSTICK.ctrl;	///< read COUNTFLAG bit to clear interrupt request	
}

void systickTimerInit(int clks, int _ms) {
	systickTimerMs = 0;
	ms = _ms;
	SYSTICK.ctrl = 0;
	SYSTICK.reload = clks/2;		// using half CCLK, see below
	SYSTICK.current = 0;			// clear counter and counter flag, regardless of value
	SYSTICK.ctrl	= 1<<_SYSTICK_CTRL_ENABLE
			| 1<<_SYSTICK_CTRL_TICKINT	// enable interrupt
			| 0<<_SYSTICK_CTRL_CLKSOURCE	// select CCLK/2
			;
}

