@ (C) Marc Prager, 2013

@ stack is now defined by ldscript
@ this startup works fine for all LPC8xx processors

.syntax unified
.arch armv6-m

.extern main		@ C program entry point
.extern handlerDefault
.weak __aeabi_idiv0
.weak handlerNmi
.weak handlerHardFault
.weak handlerSvCall
.weak handlerPendSv
.weak handlerSystick
.extern stackMainTop	@ defined in LD-script
.global interruptTable
.global irqTable
.global irqTableEnd

@ user-defined handlers:

.weak handlerSpi0		@ 0x40
.weak handlerSpi1		@ 0x44
.weak handlerUsart0		@ 0x4C

.weak handlerUsart1		@ 0x50
.weak handlerUsart2		@ 0x54

.weak handlerI2c0		@ 0x60
.weak handlerSct		@ 0x64
.weak handlerMrt		@ 0x68
.weak handlerCmp		@ 0x6C

.weak handlerWdt		@ 0x70
.weak handlerBod		@ 0x74
.weak handlerWkt		@ 0x7C

.weak handlerPinInt0		@ 0xA0
.weak handlerPinInt1		@ 0xA4
.weak handlerPinInt2		@ 0xA8
.weak handlerPinInt3		@ 0xAC

.weak handlerPinInt4		@ 0xB0
.weak handlerPinInt5		@ 0xB4
.weak handlerPinInt6		@ 0xB8
.weak handlerPinInt7		@ 0xBC


.include "inc/lpc8Symbols.s"

@.text
.section .text.vectorTable, "x"
		.align 2

		.org 0 
interruptTable:
		.word stackMainTop		@ 0x00
		.word _start			@ 0x04
		.word handlerNmi		@ 0x08
		.word handlerHardFault		@ 0x0C
		.word 0				@ 0x10
		.word 0				@ 0x14
		.word 0			@ 0x18
		.word 0				@ 0x1C - valid code checksum of vectors till (including) this location
		.word 0				@ 0x20
		.word 0				@ 0x24
		.word 0				@ 0x28
		.word handlerSvCall		@ 0x2C
		.word 0				@ 0x30
		.word 0				@ 0x34
		.word handlerPendSv		@ 0x38
		.word handlerSystick		@ 0x3C
		.org 0x40
irqTable:
		.word handlerSpi0		@ 0x40
		.word handlerSpi1		@ 0x44
		.word 0				@ 0x48
		.word handlerUsart0		@ 0x4C

		.word handlerUsart1		@ 0x50
		.word handlerUsart2		@ 0x54
		.word 0				@ 0x58
		.word 0				@ 0x5C

		.word handlerI2c0		@ 0x60
		.word handlerSct		@ 0x64
		.word handlerMrt		@ 0x68
		.word handlerCmp		@ 0x6C

		.word handlerWdt		@ 0x70
		.word handlerBod		@ 0x74
		.word 0				@ 0x78
		.word handlerWkt		@ 0x7C

		.word 0				@ 0x80
		.word 0				@ 0x84
		.word 0				@ 0x88
		.word 0				@ 0x8C

		.word 0				@ 0x90
		.word 0				@ 0x94
		.word 0				@ 0x98
		.word 0				@ 0x9C

		.word handlerPinInt0		@ 0xA0
		.word handlerPinInt1		@ 0xA4
		.word handlerPinInt2		@ 0xA8
		.word handlerPinInt3		@ 0xAC

		.word handlerPinInt4		@ 0xB0
		.word handlerPinInt5		@ 0xB4
		.word handlerPinInt6		@ 0xB8
		.word handlerPinInt7		@ 0xBC

		.org 0xC0
irqTableEnd:

.func
.thumb_func
_start:

		@ clear bss
		ldr r0,=__bss_start
		movs r1,#0
		ldr r2,=__bss_end
		subs r2,r2,r0
		bl memset
		
		bl main
		b .		@ stop

.endfunc

.func

@libgcc requirements
@ divide by zero handlers
.thumb_func
__aeabi_idiv0:

@exception handers
.thumb_func
handlerNmi:
.thumb_func
handlerHardFault:
.thumb_func
handlerSvCall:
.thumb_func
handlerPendSv:
.thumb_func
handlerSystick:

.thumb_func
handlerSpi0:
.thumb_func
handlerSpi1:
.thumb_func
handlerU0:

.thumb_func
handlerU1:
.thumb_func
handlerU2:

.thumb_func
handlerI2c0:
.thumb_func
handlerSct:
.thumb_func
handlerMrt:
.thumb_func
handlerCmp:

.thumb_func
handlerWdt:
.thumb_func
handlerBod:
.thumb_func
handlerWkt:

.thumb_func
handlerPinInt0:
.thumb_func
handlerPinInt1:
.thumb_func
handlerPinInt2:
.thumb_func
handlerPinInt3:

.thumb_func
handlerPinInt4:
.thumb_func
handlerPinInt5:
.thumb_func
handlerPinInt6:
.thumb_func
handlerPinInt7:

		bl handlerDefault
.endfunc

.end

