/* Linker script for C projects using LPC8xx with at least 4k RAM.
   Startup code omitted.
   No IAP space reserved.

   (C) Marc Prager, 2013
*/

OUTPUT_FORMAT("elf32-littlearm")
OUTPUT_ARCH(arm)
STARTUP("lpc8-ram.o")

MEMORY {
	ram (rwx)	: ORIGIN = 0x10000000, LENGTH = 4K
}

SECTIONS
{
	.text		: {
			*(.text.vectorTable)	/* My new vector table section */
			*(.text.startup)	/* new gcc (>4.3.4 ?) places main here */
			*(.text)
			__text_end = . ;
	}



	.rodata 	: {
			__rodata_start = . ;
			*(.rodata*)
			__rodata_end = . ;
			__data_romimage = . ;
	}


	
	.data		: { 
			__data_start = . ;
			*(.data)
			__data_end = . ;
	}



	.bss		: {
			__bss_start = . ;
			*(.bss) *(COMMON)
			__bss_end = . ;
	}

	.stack ALIGN(8)	: {
			stackMainBottom = . ;
			. += ORIGIN(ram) + LENGTH(ram) - ABSOLUTE(.) ;
			stackMainTop = . ;
	}
}
