#include <lpc8/gpio.h>
#include <lpc8/syscon.h>
#include <lpc8/swm.h>
#include <stdbool.h>

enum {
	LED	=15,
	LOOPS	=1000000,
};

void main(void) {
/*
 	// although the user manual says differently, the 4C version of LPC812 has the clocks already
	// switched on, that are needed for GPIO.

	// enable clocks
	SYSCON.sysAhbClkCtrl
		|= 1<<6			// GPIO clock
		| 1<<7			// switch matrix
		;

	// CLKOUT
	SYSCON.clkOutSel	=3;	// main clock
	SYSCON.clkOutUen	=0;
	SYSCON.clkOutUen	=1;
	SYSCON.clkOutDiv	=12;	// divider by this value, 0=disable

	SWM.pinAssign[8] = SWM.pinAssign[8] & 0xFF00FFFF | 0x000C0000;

	// output
*/
	GPIO.dir0 = 1<<LED;
	GPIO.set0 = 1<<LED;

	while (true) {
		for (int i=0; i<LOOPS; i++) asm volatile("nop");
		GPIO.not0 = 1<<LED;
	}
}

void __attribute__((noreturn)) handlerDefault(void) {
	while(1);
}

